/**
  *	This program takes the data from a file and splits it into words
  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>

#define FIFO_NAME "PIPE1_2"
#define MSGSIZ 6
#define PIPE_LENGTH 3

int main()
{

int 	fd,Words,i,pipe_count=0,count=0;
char 	msgbuf[MSGSIZ+1],ch,word[20];
FILE 	*fp;

printf("Program 1: Takes data from a file and splits it into words\n");

Words=0;
i=0;


	//Opening the file for reading		
	if ((fp = fopen("InputFile", "r")) == NULL)

	{

	  printf("Error opening file\n");

	  exit(1);

	}



	    //named pipe creation for write operation	
	    mknod(FIFO_NAME, S_IFIFO | 0666, 0);
	    printf("waiting for reader...\n");
	    fd = open(FIFO_NAME, O_WRONLY);
	    printf("got a reader........\n");
	

	//Now read data from file letter by letter and form words

	while((ch = (char) fgetc(fp)) != EOF )

	{	

		Words++;	

		word[i++]=ch;			

			if(Words==MSGSIZ-1)

			//send data thru pipes
			{

			word[i]='\0';

			Words=0;


			strcpy(msgbuf,word);

			        if ((count = write(fd,msgbuf,i)) == -1)
			            perror("Write:");
			        else
			            printf("Program 1: wrote %d bytes : %s\n", count,msgbuf);
			i=0;

			}	

	

	}

	//Writing leftover message onto the pipe

	if(Words < MSGSIZ)

	{

	word[i]='\0';

	strcpy(msgbuf,word);



			        if ((count = write(fd,msgbuf,i)) == -1)

			            perror("Write:");

			        else

			            printf("Writer: wrote %d bytes : %s\n", count,msgbuf);

	}

	if(count=write(fd,"*******************************",32)){}
	fclose(fp);
}
